import { IInitializable } from '@pilotlab/initializable';
import { IPromise } from '@pilotlab/result';
import { Signal } from '@pilotlab/signals';
import INodeChangeOptions from './iNodeChangeOptions';
import INodes from './iNodes';
import INodeFactory from './iNodeFactory';
import NodeEventArgs from '../nodeEventArgs';
import INodeNavigator from './iNodeNavigator';
import { NodeType } from '../nodeEnums';
export interface INode extends IInitializable {
    key: string;
    readonly create: INodeFactory;
    nodeType: NodeType;
    readonly root: INode;
    readonly parent: INode;
    readonly parentCollection: INodes;
    readonly children: INodes;
    index: number;
    readonly indexPrevious: number;
    readonly nestLevel: number;
    readonly copy: INode;
    navigate: INodeNavigator;
    readonly isRoot: boolean;
    readonly isCollection: boolean;
    readonly isAttached: boolean;
    isSignalChange: boolean;
    readonly path: string;
    added: Signal<NodeEventArgs<INode>>;
    attached: Signal<NodeEventArgs<INode>>;
    readonly changed: Signal<NodeEventArgs<INode>>;
    deleted: Signal<NodeEventArgs<INode>>;
    detached: Signal<NodeEventArgs<INode>>;
    indexChanged: Signal<NodeEventArgs<INode>>;
    delete(changeOptions?: INodeChangeOptions): IPromise<boolean>;
    setIndex(value?: number, changeOptions?: INodeChangeOptions, isRememberCurrentIndex?: boolean, isSoftSwap?: boolean): boolean;
    returnToPreviousIndex(changeOptions?: INodeChangeOptions): boolean;
    toObject(isSaveDataTypes?: boolean, isIncludeLabels?: boolean, appendToObject?: any, isForceInclude?: boolean): any;
    toJson(isSaveDataTypes?: boolean): string;
    internalIsAttached: boolean;
    internalParentCollection: INodes;
    internalSetIndex(value: number, changeOptions: INodeChangeOptions): void;
    internalAdded(changeOptions: INodeChangeOptions): void;
    internalAttached(changeOptions: INodeChangeOptions): void;
    internalChanged(args: NodeEventArgs<any>): void;
    internalDeleted(changeOptions: INodeChangeOptions): void;
    internalDetached(changeOptions: INodeChangeOptions): void;
}
export default INode;
